searchData={"items":[{"type":"module","title":"NervesLivebook","doc":"Nerves Livebook firmware","ref":"NervesLivebook.html"},{"type":"function","title":"NervesLivebook.check_internet!/0","doc":"Convenience method for checking internet-connectivity for a Livebook","ref":"NervesLivebook.html#check_internet!/0"},{"type":"function","title":"NervesLivebook.ssh_check_pass/2","doc":"","ref":"NervesLivebook.html#ssh_check_pass/2"},{"type":"function","title":"NervesLivebook.ssh_show_prompt/3","doc":"","ref":"NervesLivebook.html#ssh_show_prompt/3"},{"type":"function","title":"NervesLivebook.version/0","doc":"Return the Nerves Livebook version\n\nThis returns the version as a string.","ref":"NervesLivebook.html#version/0"},{"type":"module","title":"NervesLivebook.Fwup","doc":"","ref":"NervesLivebook.Fwup.html"},{"type":"function","title":"NervesLivebook.Fwup.upgrade/2","doc":"Upgrades the system with the specified firmware update file","ref":"NervesLivebook.Fwup.html#upgrade/2"},{"type":"module","title":"NervesLivebook.GithubRelease","doc":"Check for firmware updates from the Github releases of the NervesLivebook\nrepo. See `firmware_update.livemd` for usage.","ref":"NervesLivebook.GithubRelease.html"},{"type":"function","title":"NervesLivebook.GithubRelease.firmware_url/2","doc":"Return the URL for downloading the firmware for a target\n\nIf the target firmware isn't available, it returns an error","ref":"NervesLivebook.GithubRelease.html#firmware_url/2"},{"type":"function","title":"NervesLivebook.GithubRelease.get_all/1","doc":"Return a list of all release information","ref":"NervesLivebook.GithubRelease.html#get_all/1"},{"type":"function","title":"NervesLivebook.GithubRelease.get_latest/1","doc":"Return the latest release information from GitHub","ref":"NervesLivebook.GithubRelease.html#get_latest/1"},{"type":"function","title":"NervesLivebook.GithubRelease.get_penultimate/1","doc":"Return the penultimate release information from GitHub\n\nThis is useful for going back and forth for delta updates.","ref":"NervesLivebook.GithubRelease.html#get_penultimate/1"},{"type":"function","title":"NervesLivebook.GithubRelease.req/1","doc":"","ref":"NervesLivebook.GithubRelease.html#req/1"},{"type":"type","title":"NervesLivebook.GithubRelease.t/0","doc":"","ref":"NervesLivebook.GithubRelease.html#t:t/0"},{"type":"function","title":"NervesLivebook.GithubRelease.version/1","doc":"Return the release version as a string","ref":"NervesLivebook.GithubRelease.html#version/1"},{"type":"module","title":"NervesLivebook.MixInstall","doc":"Simulate Mix.install for Nerves Livebook\n\nNerves Livebook currently doesn't support `Mix.install/2`, but hopefully it\nwill in the future. As a workaround, check whether dependencies that the user\nspecifies are available and give them a help message if not.","ref":"NervesLivebook.MixInstall.html"},{"type":"function","title":"NervesLivebook.MixInstall.install/2","doc":"","ref":"NervesLivebook.MixInstall.html#install/2"},{"type":"module","title":"NervesLivebook.UI","doc":"Provide a simple UI using the device's built-in LEDs\n\nLivebook, of course, is the main UI. This module handles one LED for now\nsince every supported device has one.","ref":"NervesLivebook.UI.html"},{"type":"function","title":"NervesLivebook.UI.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesLivebook.UI.html#child_spec/1"},{"type":"function","title":"NervesLivebook.UI.start_link/1","doc":"Start the UI GenServer\n\nOptions:\n  * None","ref":"NervesLivebook.UI.html#start_link/1"},{"type":"module","title":"NervesLivebook.WiFiMonitor","doc":"Monitor WiFi on startup to determine if AP mode needs to be enabled\n\nThis is mostly for devices that must have a WiFi connection in order to interact and\nmake firmware changes. It checks:\n\n* If any WiFi interface available to configure\n* If any WiFi interface is configured\n* If any WiFi interface is connected\n\nIf WiFi interface is configured, but not connected, then this monitor will watch\nfor a successful connection message for 3 minutes. If no connection is established\nafter that time, then it will set the WiFi interface to AP mode to allow the user\nto connect directly to the device\n\nIf no WiFi interface is present, then this will run until presence is detected.","ref":"NervesLivebook.WiFiMonitor.html"},{"type":"function","title":"NervesLivebook.WiFiMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesLivebook.WiFiMonitor.html#child_spec/1"},{"type":"function","title":"NervesLivebook.WiFiMonitor.start_link/1","doc":"","ref":"NervesLivebook.WiFiMonitor.html#start_link/1"},{"type":"extras","title":"Nerves Livebook Firmware","doc":"# Nerves Livebook Firmware\n\n[![CircleCI](https://circleci.com/gh/nerves-livebook/nerves_livebook.svg?style=svg)](https://circleci.com/gh/nerves-livebook/nerves_livebook)\n\nThe Nerves Livebook firmware lets you try out the Nerves projects on real\nhardware without needing to build anything. Within minutes, you'll have a\nRaspberry Pi or Beaglebone running Nerves. You'll be able to run code in\n[Livebook](https://github.com/nerves-livebook/nerves_livebook) and work through Nerves\ntutorials from the comfort of your browser.\n\nLooking for a quick demo first? Click below for [Underjord's](https://underjord.io/) Nerves Quickstart video.\n\n[![Install video](assets/video.jpg)](https://www.youtube.com/watch?v=-b5TPb_MwQE)","ref":"readme.html"},{"type":"extras","title":"Prerequisites - Nerves Livebook Firmware","doc":"First, you'll need to get some hardware. Nerves Livebook supports the following\ndevices:\n\n* `bbb` - BeagleBone Black, BeagleBone Green, PocketBeagle, etc.\n* `grisp2` - [GRiSP2](https://www.grisp.org/)\n* `rpi0` - Raspberry Pi Zero or Zero W\n* `rpi0_2` - Raspberry Pi Zero 2 W or Zero 2 W (64-bit mode)\n* `rpi` - The original Raspberry Pi Model B\n* `rpi2` Raspberry Pi 2 Model B\n* `rpi3` - Raspberry Pi 3 Model B and Model B+\n* `rpi3a` - Raspberry Pi 3 Model A+ (32-bit mode)\n* `rpi4` - Raspberry Pi 4 Model B\n* `rpi5` - Raspberry Pi 5 Model B\n* `osd32mp1` - Octavo OSD32MP1-BRK\n* `npi_imx6ull` - Seeed Studio imx6ull (select the MicroSD boot mode switches)\n* `mangopi_mq_pro` - MangoPi MQ Pro (Allwinner D1 64-bit RISC-V)\n\nSome of these are easier than others to use. If you have a choice, the Raspberry\nPi Zero, Raspberry Pi 4 and BeagleBones are good ones to try first. These boards\nhave a lot of functionality and connecting them to a network is a little easier\nthan the others.","ref":"readme.html#prerequisites"},{"type":"extras","title":"Downloading the Firmware - Nerves Livebook Firmware","doc":"If you're using a GRiSP 2, skip to the installation instructions below for it.\n\nFirst, find the appropriate firmware or zip'd image file for your hardware in the\n[releases](https://github.com/nerves-livebook/nerves_livebook/releases). This is a\none time step. There's a Livebook notebook for upgrading the firmware for when\nwe make releases!\n\nYou have two firmware packaging options. The first is to use the\n[`fwup`](https://github.com/fwup-home/fwup) commandline application and the\nother is to use a program like [Etcher](https://www.balena.io/etcher/). Download\nthe file with the `.fw` extension for `fwup` and the `zip` file for Etcher. If\nyou're ok with the commandline, using `fwup` will come in handy if you start using\nNerves more.\n\nOnce the download completes, you're ready to install the firmware on your device.","ref":"readme.html#downloading-the-firmware"},{"type":"extras","title":"Burning the Firmware for devices that boot from MicroSD - Nerves Livebook Firmware","doc":"These instructions will work for the Raspberry Pi, Beaglebones and other devices\nthat either boot off MicroSD cards or can be configured to do so. If you're\nusing a GRiSP 2, see the GRiSP 2 installation section.\n\nNavigate to the directory where you downloaded the firmware. Either `fwup` or\n`etcher` can be used to burn the firmware.\n\nTo be clear, this formats your SD card, and you will *lose all data on the SD\ncard*. Make sure you're OK with that.\n\n### `fwup`\n\nYou'll need to install `fwup` if you don't have it. On Mac, run `brew install\nfwup`. For Linux and Windows, see the [fwup installation\ninstructions](https://github.com/fwup-home/fwup#installing).\n\n```sh\n$ fwup nerves_livebook_rpi0.fw\nUse 15.84 GB memory card found at /dev/rdisk2? [y/N] y\n```\n\nDepending on your OS, you'll likely be asked to authenticate this action. Go\nahead and do so.\n\n```console\n|====================================| 100% (31.81 / 31.81) MB\nSuccess!\nElapsed time: 3.595 s\n```\n\nIf you're using a WiFi-enabled device and want the WiFi credentials to be\nwritten to the MicroSD card, initialize the MicroSD card like this instead:\n\n```sh\nsudo NERVES_WIFI_SSID='access_point' NERVES_WIFI_PASSPHRASE='passphrase' fwup nerves_livebook_rpi0.fw\n```\n\nYou can still change the WiFi credentials at runtime using\n`VintageNetWiFi.quick_configure/2`, but this helps if you don't have an easy way of\naccessing the device to configure WiFi.\n\nNow you have Nerves Livebook ready to run on your device. Skip ahead to the next\nsection.\n\n### `etcher`\n\nStart [`etcher`](https://www.balena.io/etcher/), point it to the zip file, and\nfollow the prompts:\n\n![etcher screenshot](assets/etcher.png)\n\nIMPORTANT: There's no way to configure the initial WiFi credentials with\n`etcher`. If you have a device that you can only access via WiFi (so no way of\nsetting credentials), then check out the `fwup` instructions above.","ref":"readme.html#burning-the-firmware-for-devices-that-boot-from-microsd"},{"type":"extras","title":"GRiSP 2 installation - Nerves Livebook Firmware","doc":"GRiSP 2 support is VERY new. While it should be safe, it's probably a good idea\nto skim the\n[instructions](https://github.com/grisp/grisp_demo/tree/sylane/make-image) for\nre-installing the GRiSP demo app. If that doesn't look that hard, then let's\ncontinue:\n\nAssuming you don't already have a Nerves firmware on your GRiSP 2, you'll need\nto do a first time install. Even if you do have Nerves on your GRiSP 2, you can\nstill follow these instructions.\n\nFirst, download `nerves_livebook_grisp2.img.gz`from the latest\n[releases](https://github.com/nerves-livebook/nerves_livebook/releases).\n\n1. Copy `nerves_livebook_grisp2.img.gz` to a FAT-formatted MicroSD card:\n\n        $ cp nerves_livebook_grisp2.img.gz /Volumes/...\n\n2. Unmount the MicroSD card and insert it into the GRiSP 2.\n\n3. Connect the GRiSP 2 to your computer via USB via `picocom` or another\n   serial terminal program. The GRiSP 2 shows up as two serial ports. Connect to\n   second one. On MacOS, it's `/dev/tty.usbserial-0 1`.\n\n4. Press the reset button on the GRiSP 2. Press a key on the serial console to\n   get a Barebox prompt.\n\n5. At the Barebox prompt, run:\n\n        :/ uncompress /mnt/mmc/nerves_livebook_grisp2.img.gz /dev/mmc1\n        :/ reset\n\n6. The GRiSP 2 will reboot into the Nerves Livebook firmware. The first boot\n   takes a little longer due to it initializing the application data partition.\n\nOnce it boots, you can use the IEx prompt over the USB cable or connect over\nEthernet. There's a sticker on the back of the GRiSP with the serial number. The\ndevice will be at `nerves- .local` on the network.\n\nTo configure WiFi, run:\n\n```elixir\nVintageNetWiFi.quick_configure(\"ssid\", \"password\")\n```\n\n`VintageNet.info` will show the current state of the network connections.\n\nThe normal Nerves firmware update methods will work. Since the GRiSP 2 port\nis so new, it may be required to perform a fresh install using the above\ninstructions in the future.\n\nTo see the current progress of the GRiSP 2 port to Nerves, see\n[nerves_system_grisp2](https://github.com/fhunleth/nerves_system_grisp2).","ref":"readme.html#grisp-2-installation"},{"type":"extras","title":"Running the Firmware - Nerves Livebook Firmware","doc":"Eject the SD card and insert it into the device that you're using. Power up the\ndevice and connect a network cable. If you're using a Raspberry Pi Zero,\nBeaglebone or Raspberry Pi 4, a USB cable can provide both power and network.\n\nThe first boot can take longer than subsequent boots due to initializing the\ndata filesystem for storing your notebooks. It is noticeable especially on large\nMicroSD cards.\n\nMost, but not all supported devices, have an LED on them. Nerves Livebook will\nmake it blink when the network is disconnected and change it to solid on when\nit's possible to connect over any network interface.\n\nOnce the device is ready, point your browser at http://nerves.local. The password\nis \"nerves\".\n\n![Livebook screenshot](assets/livebook.jpg)","ref":"readme.html#running-the-firmware"},{"type":"extras","title":"Special Windows setup - Nerves Livebook Firmware","doc":"Microsoft Windows requires a device driver to be installed to support networking\nover a USB cable:\n\n1. Download the [USB Ethernet/RNDIS Gadget driver](https://www.catalog.update.microsoft.com/Search.aspx?q=usb%5Cvid_0525%26pid_a4a2)\n   from the Microsoft Update Catalog\n2. Connect your Raspberry Pi or Beaglebone that's running Nerves Livebook to\n   your computer\n3. Start Device Manager\n4. You should see a COM device show up\n   1. Right click on it and update the driver\n   2. Select \"Let me pick\", then \"Have disk\", and point it at the digitally\n      signed inf/cat files downloaded in step 1\n5. Once the COM device changes into a \"USB Ethernet/RNDIS Gadget\" device you'll\n   be able to visit [nerves.local](http://nerves.local) in a browser","ref":"readme.html#special-windows-setup"},{"type":"extras","title":"Going further - Nerves Livebook Firmware","doc":"At some point you may want to customize Nerves Livebook. See the [Nerves\nInstallation](https://hexdocs.pm/nerves/installation.html) and [Getting\nStarted](https://hexdocs.pm/nerves/getting-started.html) guides for details.\n\nTo build the Nerves Livebook firmware, make sure that you have run through the\nNerves installation steps. Then open a terminal window and run the following:\n\n```sh\n$ git clone https://github.com/nerves-livebook/nerves_livebook.git\n$ cd nerves_livebook\n\n# Set the MIX_TARGET to the desired platform (rpi0, bbb, rpi3, etc.)\n$ export MIX_TARGET=rpi0\n$ mix deps.get\n$ mix firmware\n\n# Option 1: Insert a MicroSD card\n$ mix burn\n\n# Option 2: Upload to an existing Nerves Livebook device\n$ mix firmware.gen.script\n$ ./upload.sh livebook@nerves.local\n```","ref":"readme.html#going-further"},{"type":"extras","title":"Firmware provisioning options - Nerves Livebook Firmware","doc":"Nerves Livebook supports some device-specific customization after the firmware\nhas been created. This means that you don't need to rebuild the firmware to set\nany of the options in this section. Instead, they are set when you use `fwup` to\ninitialize a MicroSD card. Here's an example invocation of `fwup` to show what\nto do:\n\n```sh\nsudo NERVES_WIFI_SSID='access_point' NERVES_WIFI_PASSPHRASE='passphrase' fwup nerves_livebook_rpi0.fw\n```\n\nSee the `config/provisioning.conf` for details. Here is a summary of the\noptions:\n\nEnvironment variable | Nerves.Runtime.KV key | Description\n ------------------- | --------------------- | -----------\nNERVES_SERIAL_NUMBER | nerves_serial_number  | Set the device serial number to the specified text (default is to use device-specific unique ID)\nNERVES_WIFI_FORCE    | wifi_force            | Set to `true` to always set WiFi credentials on boot even if other ones were previously set\nNERVES_WIFI_PASSPHRASE | wifi_passphrase     | A WiFi passphrase to use if WiFi hasn't been configured\nNERVES_WIFI_SSID     | wifi_ssid             | A WiFi SSID to use if WiFi hasn't been configured","ref":"readme.html#firmware-provisioning-options"},{"type":"extras","title":"License - Nerves Livebook Firmware","doc":"Copyright (C) 2021-22 Frank Hunleth\n\n    Licensed under the Apache License, Version 2.0 (the \"License\");\n    you may not use this file except in compliance with the License.\n    You may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\n    Unless required by applicable law or agreed to in writing, software\n    distributed under the License is distributed on an \"AS IS\" BASIS,\n    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n    See the License for the specific language governing permissions and\n    limitations under the License.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.15.5 - 2025-04-03 - Changelog","doc":"* Updates\n  * Update to [Livebook v0.15.5](https://github.com/livebook-dev/livebook/releases/tag/v0.15.5)\n  * Update Nerves systems to [nerves_system_br v1.30.0](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.30.0)\n  * Update all dependencies","ref":"changelog.html#v0-15-5-2025-04-03"},{"type":"extras","title":"v0.14.2 - 2025-01-22 - Changelog","doc":"* Updates\n  * Update Nerves systems to [nerves_system_br v1.29.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.29.3)\n  * Add support for the RPi CM5 and other BCM2712 D0 silicon RPi5's\n  * Update to Elixir 1.18.2 and Erlang/OTP 27.2\n  * Update all dependencies","ref":"changelog.html#v0-14-2-2025-01-22"},{"type":"extras","title":"v0.14.1 - 2024-11-28 - Changelog","doc":"* Updates\n  * Update to [Livebook v0.14.5](https://github.com/livebook-dev/livebook/releases/tag/v0.14.5)\n  * Update Nerves systems to [nerves_system_br v1.29.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.29.1)\n  * Update all dependencies\n  * Added notebook for connecting to NervesHub (Thanks @lawik)","ref":"changelog.html#v0-14-1-2024-11-28"},{"type":"extras","title":"v0.14.0 - 2024-9-04 - Changelog","doc":"* Updates\n  * Update to [Livebook v0.14.0](https://github.com/livebook-dev/livebook/releases/tag/v0.14.0)\n  * Update Nerves systems to [nerves_system_br v1.28.3](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.3)\n  * Add `vintage_net_qmi` to dependencies to use some cellular modems on Raspberry Pis and Beaglebones with USB host ports. These boards include QMI device drivers in this release.\n  * Update all dependencies\n  * Fix tflite sample notebook (Thanks @mnishiguchi)","ref":"changelog.html#v0-14-0-2024-9-04"},{"type":"extras","title":"v0.13.0 - 2024-7-14 - Changelog","doc":"* Updates\n  * Update to [Livebook v0.13.3](https://github.com/livebook-dev/livebook/releases/tag/v0.13.3). Also see the [v0.13.0 changes](https://github.com/livebook-dev/livebook/releases/tag/v0.13.0)\n  * Update to Elixir 1.17.2 and Erlang/OTP 27.0\n  * Update Nerves systems to [nerves_system_br v1.28.1](https://github.com/nerves-project/nerves_system_br/releases/tag/v1.28.1)\n  * Update all dependencies to latest versions\n  * Remove `picam` from 32-bit Raspberry Pi releases due to the switch from MMAL to `libcamera`","ref":"changelog.html#v0-13-0-2024-7-14"},{"type":"extras","title":"v0.12.3 - 2024-4-7 - Changelog","doc":"* Updates\n  * Update Nerves systems to `nerves_system_br v1.27.0` (Erlang/OTP 26.2.3,\n    Buildroot 2024.02)\n  * Switch back to WPA2-only WiFi support with\n    `VintageNetWiFi.quick_configure/2` to fix issues on BBB and GRiSP2\n  * Fix regression that prevented WiFi networks from being provisioned on the\n    MicroSD card\n  * Removed `srhub` target due to perceived lack of use. If this is not true,\n    please open an issue and we'll include it again.\n  * Update all dependencies to latest versions","ref":"changelog.html#v0-12-3-2024-4-7"},{"type":"extras","title":"v0.12.2 - 2024-2-18 - Changelog","doc":"* Updates\n  * Update `vintage_net_wifi` to fix an issue connecting to some WPA2 networks\n    using `VintageNetWiFi.quick_configure/2`\n  * Enable TFLite support on Raspberry Pi Model B and Raspberry Pi Zeros now\n    that it has ARMv6 support. (@cocoa-xu)\n  * Update Nerves systems to `nerves_system_br` 1.25.1 versions (Erlang 26.2.2)\n  * Update all dependencies to latest versions","ref":"changelog.html#v0-12-2-2024-2-18"},{"type":"extras","title":"v0.12.1 - 2024-1-21 - Changelog","doc":"* Updates\n  * Fix LED naming changes from Linux kernel update that ended up breaking RPi\n    Zero, 2, and 3.\n  * Update Nerves systems to nerves_system_br 1.24.1 versions (Erlang 26.2.1)\n  * Add WPA3 support for devices with WiFi modules that support it (currently\n    only BeagleBone's with WiLink modules)\n  * Update all dependencies to latest versions\n  * Fix diagnostics notebook (@mnisiguchi)\n  * Fix firmware update notebook (@5avage)","ref":"changelog.html#v0-12-1-2024-1-21"},{"type":"extras","title":"v0.12.0 - 2024-1-1 - Changelog","doc":"Happy New Year!\n\n* Updates\n  * Update Livebook to [v0.12.1](https://github.com/livebook-dev/livebook/releases/tag/v0.12.1)\n  * Fix Raspberry Pi 3 regression in v0.11.1\n  * Update Elixir to 1.16.0\n  * SBOM generation is temporarily off pending a PR getting merged","ref":"changelog.html#v0-12-0-2024-1-1"},{"type":"extras","title":"v0.11.1 - 2023-12-19 - Changelog","doc":"* Updates\n  * Add 64-bit RPi Zero 2W (`rpi0_2`). 32-bit mode was supported before via\n    `rpi3a`, but this enables the JIT\n  * Add RPi 5 (`rpi5`). This port is current experimental\n  * Update Nerves systems to nerves_system_br 1.25.2 versions\n    * Erlang 26.1.2\n    * Buildroot 2023.08.4\n    * Linux 6.1 on all Raspberry Pi and BBB ports\n  * Update Elixir to 1.15.7\n  * Update all dependencies to their latest versions","ref":"changelog.html#v0-11-1-2023-12-19"},{"type":"extras","title":"v0.11.0 - 2023-10-09 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.11.0](https://github.com/livebook-dev/livebook/releases/tag/v0.11.0)\n  * Update Nerves systems to nerves_system_br 1.24.1 versions\n    * Erlang 26.1.1\n    * Buildroot 2023.05.3\n  * Update Elixir to 1.15.6\n  * Update all dependencies to their latest versions","ref":"changelog.html#v0-11-0-2023-10-09"},{"type":"extras","title":"v0.10.1 - 2023-07-29 - Changelog","doc":"* Updates\n  * Add `:tflite_elixir` back since it works again\n  * Update Nerves systems to nerves_system_br 1.23.2 versions to get CTRL+R fix\n    for ssh sessions (and more).\n  * Improve PMOD support on GRiSP 2\n  * Update Elixir to 1.15.4","ref":"changelog.html#v0-10-1-2023-07-29"},{"type":"extras","title":"v0.10.0 - 2023-07-14 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.10.0](https://github.com/livebook-dev/livebook/releases/tag/v0.10.0)\n  * Update Nerves systems to nerves_system_br 1.23.1 versions. This includes:\n    * Erlang 26.0.2\n    * Support for all Raspberry Pi Cameras via libcamera on the RPi4\n    * Buildroot 2023.02.2\n    * Linux updates on various systems\n  * Update Elixir to 1.15.2\n  * Update all dependencies to their latest versions\n\nNOTE: `:tflite_elixir` is temporily removed due to build errors.","ref":"changelog.html#v0-10-0-2023-07-14"},{"type":"extras","title":"v0.9.1 - 2023-05-14 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.9.2](https://github.com/livebook-dev/livebook/releases/tag/v0.9.2)\n  * Include TFLite (`:tflite_elixir`) for all devices that support TensorFlow\n    Lite (all but Raspberry Pi 1 and Raspberry Pi Zero). See the `tflite.livemd`\n    sample to a quick intro. Thanks to Masatoshi Nishiguchi for this.\n  * Update all dependencies to their latest versions.","ref":"changelog.html#v0-9-1-2023-05-14"},{"type":"extras","title":"v0.9.0 - 2023-04-05 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.9.1](https://github.com/livebook-dev/livebook/releases/tag/v0.9.1)\n  * Update Nerves systems to nerves_system_br 1.22.5 versions. This includes\n    Erlang 25.3 and fixes to the Raspberry Pi 3 to support TensorFlow Lite.\n    (TFLite isn't built into Nerves Livebook yet)\n  * Update all dependencies to their latest versions.\n\n* Fixes\n  * Fixed LEDs on SRHub images (Thanks to Eric Oestrich)","ref":"changelog.html#v0-9-0-2023-04-05"},{"type":"extras","title":"v0.8.3 - 2023-03-12 - Changelog","doc":"* Updates\n  * Generate and post docs to hex.pm so that hyperlinks work when calling\n    NervesLivebook functions\n  * Update Nerves systems to nerves_system_br 1.22.3 versions. This includes\n    Erlang 25.2.3 and an update for Rust support. Libraries using Rust aren't\n    included yet due to an issue on 32-bit platforms, but will likely be\n    included in the next release.\n  * Update all dependencies to their latest versions.","ref":"changelog.html#v0-8-3-2023-03-12"},{"type":"extras","title":"v0.8.2 - 2023-02-11 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.8.1](https://github.com/livebook-dev/livebook/releases/tag/v0.8.2)\n  * Update all dependencies to latest (Nx 0.5.0, RingLogger 0.9.0, Toolshed\n    0.3.0, VintageNet 0.13.0)\n  * Configure the Erlang compiler for deterministic builds","ref":"changelog.html#v0-8-2-2023-02-11"},{"type":"extras","title":"v0.8.1 - 2023-01-17 - Changelog","doc":"IMPORTANT: The MangoPi MQ Pro has a major update that makes it non-backwards\ncompatible despite this release's version number. This is due to hacks to\nsupport it being removed that unfortunately caused the MicroSD card contents to\nbe changed. Please move your work off your current MicroSD cards and re-flash\nit. Upgrading is not supported.\n\n\n* Updates\n  * Update Nerves systems to `nerves_system_br` 1.22.1 versions (Buildroot 2022.11)\n  * Update MangoPi MQ Pro to Linux 6.1\n  * Switch MangoPi MQ Pro from Musl Libc to Glibc (better Rust support)\n  * Update all toolchains to use GCC 12.2\n  * Update all provided mix libraries to their latest","ref":"changelog.html#v0-8-1-2023-01-17"},{"type":"extras","title":"v0.8.0 - 2022-12-19 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.8.0](https://github.com/livebook-dev/livebook/releases/tag/v0.8.0)\n  * Reduced logger level to warning to reduce clutter when evaluating cells.\n    This is a the same default level as regular Livebook.\n  * Support the shutdown button. This will gracefully power off your device.\n    Note that Nerves Livebook syncs notebooks to minimizing losing notebook\n    changes already, but this is an additional way to make sure everything has been\n    flushed to storage when you're done.\n  * Update Nerves systems to `nerves_system_br` 1.21.6 versions (Erlang/OTP 25.2)\n  * Update all provided mix libraries to their latest.","ref":"changelog.html#v0-8-0-2022-12-19"},{"type":"extras","title":"v0.7.2 - 2022-11-07 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.7.2](https://github.com/livebook-dev/livebook/releases/tag/v0.7.2)\n  * Update Nerves systems to `nerves_system_br` 1.21.2 versions\n  * Fix hyperlinks and move more pages to learn sections (Thanks @mnishiguchi)","ref":"changelog.html#v0-7-2-2022-11-07"},{"type":"extras","title":"v0.7.0 - 2022-10-09 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.7.1](https://github.com/livebook-dev/livebook/releases/tag/v0.7.1)\n  * Update Nerves systems to `nerves_system_br` 1.20.6 versions\n  * Update Nerves to v1.9.1","ref":"changelog.html#v0-7-0-2022-10-09"},{"type":"extras","title":"v0.6.5 - 2022-08-29 - Changelog","doc":"* Updates\n  * Add WiFi configuration to explore section to make it easier to find\n  * Use the new `Delux` library to control the LED. This will enable better\n    feedback for what Livebook is doing when you can't see the webpage\n  * Blink LED to show that the RPi0 is booting since it takes so long to start.\n  * Add the `Pinout` library as a convenience for getting board pinouts.\n  * Add libraries for devices that support cellular modems (only `srhub` now)","ref":"changelog.html#v0-6-5-2022-08-29"},{"type":"extras","title":"v0.6.4 - 2022-08-08 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.6.3](https://github.com/livebook-dev/livebook/releases/tag/v0.6.3)\n  * Update Nerves systems to `nerves_system_br` 1.20.4 versions. This includes\n    Erlang/OTP 25.0.3, Buildroot 2022.05, and GCC 11.3.\n  * Fix warnings when building in host mode. (Thanks @axelson)\n  * Update dependencies to latest versions\n  * Add preliminary support for srhub devices","ref":"changelog.html#v0-6-4-2022-08-08"},{"type":"extras","title":"v0.6.3 - 2022-07-08 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.6.2](https://github.com/livebook-dev/livebook/releases/tag/v0.6.2)\n  * Support the 64-bit RISC-V MangoPi MQ Pro\n  * Change the WiFi regulatory domain default from `US` to the global region (`00`)\n  * Update Nerves systems to `nerves_system_br` 1.20.3 versions. This includes\n    Erlang/OTP 25.0.2, Buildroot 2022.05, and GCC 11.3.","ref":"changelog.html#v0-6-3-2022-07-08"},{"type":"extras","title":"v0.6.2 - 2022-05-26 - Changelog","doc":"* Updates\n  * Update to Erlang 25.0 - Enables JIT on Raspberry Pi 4!\n  * Update Nerves systems to `nerves_system_br` 1.19.0 versions to bring in\n    security and bug fixes","ref":"changelog.html#v0-6-2-2022-05-26"},{"type":"extras","title":"v0.6.1 - 2022-05-20 - Changelog","doc":"* Updates\n  * Include `:kino_vega_lite` so that graphs render again. (Thanks @petermm)\n  * Improve WiFi configuration book (Thanks @petermm)","ref":"changelog.html#v0-6-1-2022-05-20"},{"type":"extras","title":"v0.6.0 - 2022-05-07 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.6.1](https://github.com/livebook-dev/livebook/releases/tag/v0.6.1)","ref":"changelog.html#v0-6-0-2022-05-07"},{"type":"extras","title":"v0.5.7 - 2022-03-18 - Changelog","doc":"* Updates\n  * Update to Erlang 24.3.2\n  * Various modest boot time improvements in dependent libraries","ref":"changelog.html#v0-5-7-2022-03-18"},{"type":"extras","title":"v0.5.6 - 2022-03-03 - Changelog","doc":"* Updates\n  * Various small improvements for the GRiSP 2\n  * Add support for the Beaglebone Green Gateway (bbb target)\n  * Update to Erlang 24.2.2","ref":"changelog.html#v0-5-6-2022-03-03"},{"type":"extras","title":"v0.5.5 - 2022-02-28 - Changelog","doc":"* Updates\n  * Add experimental support for GRiSP 2. See README.md for installation.","ref":"changelog.html#v0-5-5-2022-02-28"},{"type":"extras","title":"v0.5.4 - 2022-02-18 - Changelog","doc":"* Updates\n  * Update Nerves Systems to `nerves_system_br` 1.18.4 versions. This brings in\n    Buildroot and Erlang patch releases.\n  * Add `picam` for devices that support it (Raspberry Pi Zero, A, B, 2, and 3).\n\n* Fixes\n  * Fix import via file upload","ref":"changelog.html#v0-5-4-2022-02-18"},{"type":"extras","title":"v0.5.3 - 2022-02-05 - Changelog","doc":"* Updates\n  * Pulled in a fix for scanning WiFi access points when an Eero mesh system is\n    nearby.","ref":"changelog.html#v0-5-3-2022-02-05"},{"type":"extras","title":"v0.5.2 - 2022-01-31 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.5.2](https://github.com/livebook-dev/livebook/releases/tag/v0.5.2)\n  * Turn on an LED when networking on the device is ready. This isn't perfect\n    for showing status, but aims to be more helpful than the current lack of\n    feedback.","ref":"changelog.html#v0-5-2-2022-01-31"},{"type":"extras","title":"v0.5.1 - 2022-01-25 - Changelog","doc":"* Updates\n  * Fix regression in v0.5.0 with plotting graphs with VegaLite\n  * Update Circuits.SPI to pull in support for lsb-first devices","ref":"changelog.html#v0-5-1-2022-01-25"},{"type":"extras","title":"v0.5.0 - 2022-01-20 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.5.1](https://github.com/livebook-dev/livebook/releases/tag/v0.5.1)","ref":"changelog.html#v0-5-0-2022-01-20"},{"type":"extras","title":"v0.4.2 - 2022-01-16 - Changelog","doc":"* Updates\n  * Add `req` to the built-in hex packages\n  * Update Nerves Systems to `nerves_system_br` 1.18.3 versions. This brings in\n    a `cpufreq` fix, OpenMP support, and CMake support\n  * Update Elixir to 1.13.2","ref":"changelog.html#v0-4-2-2022-01-16"},{"type":"extras","title":"v0.4.1 - 2021-12-31 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.4.1](https://github.com/livebook-dev/livebook/releases/tag/v0.4.1)\n  * Update Elixir to 1.13.1\n  * Update Nerves Systems to use Erlang 24.2, Buildroot 2021.11 and\n    miscellaneous platform-specific bug fixes and improvements.\n  * Update various other dependencies to their latest versions","ref":"changelog.html#v0-4-1-2021-12-31"},{"type":"extras","title":"v0.4.0 - 2021-12-05 - Changelog","doc":"* Updates\n  * Update Livebook to [v0.4.0](https://github.com/livebook-dev/livebook/releases/tag/v0.4.0)\n  * Update Elixir to 1.13.0\n  * Update Nerves Systems to use Erlang 24.1.7, Buildroot 2021.08.2 and\n    miscellaneous platform-specific bug fixes and improvements.","ref":"changelog.html#v0-4-0-2021-12-05"},{"type":"extras","title":"v0.3.2 - 2021-11-13 - Changelog","doc":"* Updates\n  * Update Livebook to v0.3.2\n  * Simplify ssh login to not care about the username\n  * Update Nerves systems. This brings in support for the new Raspberry Pi Zero\n    2 W. Use the `rpi3a` version for the Zero 2 W.","ref":"changelog.html#v0-3-2-2021-11-13"},{"type":"extras","title":"v0.3.1 - 2021-10-27 - Changelog","doc":"* Updates\n  * Update Livebook to v0.3.1","ref":"changelog.html#v0-3-1-2021-10-27"},{"type":"extras","title":"v0.3.0 - 2021-10-19 - Changelog","doc":"* Updates\n  * Update Livebook to v0.3.0\n  * Include ExUnit to support notebooks with tests","ref":"changelog.html#v0-3-0-2021-10-19"},{"type":"extras","title":"v0.2.27 - 2021-10-16 - Changelog","doc":"* Updates\n  * Update to Erlang 24.1.2 and Buildroot 2021.08.1\n  * Update Livebook to latest. Pulls in dynamic favicon.","ref":"changelog.html#v0-2-27-2021-10-16"},{"type":"extras","title":"v0.2.26 - 2021-10-09 - Changelog","doc":"* Updates\n  * Fix boot issue on Seeed Studio's NPi iMX6ULL board\n  * Selectively include BlueHeron since it doesn't work on all boards","ref":"changelog.html#v0-2-26-2021-10-09"},{"type":"extras","title":"v0.2.25 - 2021-10-07 - Changelog","doc":"* Updates\n  * Initial Bluetooth support is available for the Raspberry Pi Zero W and 3B.\n    If you have either of these boards, take a look at\n    `bluetooth/ble_device_with_nerves.livemd`. Thanks to Troels Brødsgaard for\n    contributing this.\n  * Include Nx so that the the Nx tutorial works\n  * Update MdnsLite and make the advertised services look pretty on devices that\n    support mDNS. The default is to show up as \"Nerves Livebook\" and advertise\n    HTTP, SSH, SFTP, and Erlang distribution.","ref":"changelog.html#v0-2-25-2021-10-07"},{"type":"extras","title":"v0.2.24 - 2021-10-05 - Changelog","doc":"The default location for notebooks on the device has changed from\n`/data/livebooks` to `/data/livebook` for consistency. If you're upgrading to\nthis release, the old directory will be kept in case any modifications were made\nto notebooks there.\n\n* Updates\n  * Update Livebook from `v0.2.3` to [`main@d8a7af62`](https://github.com/livebook-dev/livebook/blob/d8a7af62e78c664b667cb30c8430a1b56e412500/CHANGELOG.md).\n    See the unreleased items in the link for Livebook changes.\n  * Redirect to the device's specific hostname when using `nerves.local` to\n    connect. This makes it more obvious which device you're connected to when\n    multiple Nerves Livebook devices are accessible.","ref":"changelog.html#v0-2-24-2021-10-05"},{"type":"extras","title":"v0.2.23 - 2021-10-01 - Changelog","doc":"* Updates\n  * Several networking notebook additions and improvements. Thanks to Jon\n    Carstens for these.\n  * Pull in a subtle mDNS/DNS issue lookup issue that affected using .local\n    addresses on some networks\n  * Pull in Bluetooth support fixes. BLE works on Raspberry Pi Zeros and\n    Raspberry Pi 3s now, but it's not convenient and there aren't any sample\n    notebooks. We hope to change that soon.\n  * You can transfer files using `scp` in addition to `sftp` from Nerves\n    Livebook devices now.","ref":"changelog.html#v0-2-23-2021-10-01"},{"type":"extras","title":"v0.2.22 - Changelog","doc":"* Updates\n  * Upgrade to `nerves_system_br` `1.17.0`-based systems. These include Erlang\n    24.1 and Buildroot 2021.08.","ref":"changelog.html#v0-2-22"},{"type":"extras","title":"v0.2.21 - Changelog","doc":"* Updates\n  * Update all URLs to point to the `nerves_livebook` home on the `livebook-dev`\n    GitHub repository","ref":"changelog.html#v0-2-21"},{"type":"extras","title":"v0.2.20 - Changelog","doc":"* Updates\n  * The Raspberry Pi 4 USB-C port can now be used for power and data. This is\n    similar to the Raspberry Pi Zero, 3A and BBB.\n  * Minor updates to a variety of packages","ref":"changelog.html#v0-2-20"},{"type":"extras","title":"v0.2.19 - Changelog","doc":"* Updates\n  * Use new Nerves MOTD for ssh logins","ref":"changelog.html#v0-2-19"},{"type":"extras","title":"v0.2.18 - Changelog","doc":"* Updates\n  * Livebook 0.2.3\n  * Update to MdnsLite 0.8.0 and enable support for using mDNS (.local)\n    addresses with Erlang distribution and more\n  * Update various other Nerves dependencies","ref":"changelog.html#v0-2-18"},{"type":"extras","title":"v0.2.17 - Changelog","doc":"* Updates\n  * Make Erlang distribution predictable. It's now\n    `livebook@nerves- .local`. From within Livebook, you can see the\n    name by going to the settings tab. This is an mDNS name and will work even\n    if the IP address to the device changes. It only requires an mDNS client on\n    your computer which is included by default on MacOS and usually on Linux.","ref":"changelog.html#v0-2-17"},{"type":"extras","title":"v0.2.16 - Changelog","doc":"* Updates\n  * Support provisioning WiFi when creating the MicroSD card. See `README.md`\n    for how to pass parameters when calling `fwup`.\n  * Check that dependencies passed to `Mix.install/1` are compatible with what's\n    included in Nerves Livebook. Installation isn't supported yet, but this\n    update makes it possible to include `Mix.install/1` calls in your livebooks\n    for when it does work.","ref":"changelog.html#v0-2-16"},{"type":"extras","title":"v0.2.15 - Changelog","doc":"* Updates\n  * Minor version bumps on many dependencies - no new features","ref":"changelog.html#v0-2-15"},{"type":"extras","title":"v0.2.14 - Changelog","doc":"* Updates\n  * Update to OTP 24-based Nerves systems\n  * Livebook 0.2.2","ref":"changelog.html#v0-2-14"},{"type":"extras","title":"v0.2.13 - Changelog","doc":"* Updates\n  * Update Livebook to 0.1.2\n  * The `vega_lite` and `kino` packages are available so it's now possible to\n    experiment with plotting sensor data. Note that `Mix.install` doesn't work\n    yet so if you're trying out a notebook that uses `vega_lite`, just uncomment\n    the `Mix.install` parts for now.","ref":"changelog.html#v0-2-13"},{"type":"extras","title":"v0.2.12 - Changelog","doc":"* Updates\n  * Organize sample livebooks into directories so that they're easier to find.\n    More changes are coming. Thanks to DJ Carpenter for spearheading the effort\n    better organize this project.\n  * Add a delta firmware update livebook. This livebook can't be used just yet.\n    It needs a release to update to. Once v0.2.13 is available, it will work.","ref":"changelog.html#v0-2-12"},{"type":"extras","title":"v0.2.11 - Changelog","doc":"* Updates\n  * Add NervesKey (ATECC508A/608) provisioning example. Thanks to Alex McLain\n    for contributing this.\n  * Building delta firmware updates on CI. This lays the groundwork for future\n    livebooks.","ref":"changelog.html#v0-2-11"},{"type":"extras","title":"v0.2.10 - Changelog","doc":"* Updates\n  * Update to Livebook 0.1.1\n  * Add PWM example using Pigpiox for Raspberry Pis. Thanks to DJ Carpenter for\n    contributing this.","ref":"changelog.html#v0-2-10"},{"type":"extras","title":"v0.2.9 - Changelog","doc":"* Updates\n  * Update to Elixir 1.12.0 and Livebook 0.1.0\n  * Various BMP280 Livebook and library updates","ref":"changelog.html#v0-2-9"},{"type":"extras","title":"v0.2.8 - Changelog","doc":"Community update release!\n\n* Updates\n  * Thanks to Jonatan Klosko, upstream Livebook now supports embedded mode so we\n    can use it on Nerves without patching it. This release has zero custom\n    Livebook patches for Nerves.\n  * DJ Carpenter has started reorganizing the samples directory to make it\n    easier to find examples. He also added a GPIO button example.\n  * Masatoshi Nishiguchi has updates to the BMP280\n    temperature/humidity/barometric sensor example too","ref":"changelog.html#v0-2-8"},{"type":"extras","title":"v0.2.7 - Changelog","doc":"* Updates\n  * Add Circuits.GPIO example from DJ Carpenter\n  * Add BMP280 example from Masatoshi Nishiguchi","ref":"changelog.html#v0-2-7"},{"type":"extras","title":"v0.2.6 - Changelog","doc":"* Updates\n  * Use Elixir 1.12.0-rc.1. This enables some Livebook features that I haven't\n    tested yet, but look cool.\n  * Update Livebook to the latest to pull in user profiles","ref":"changelog.html#v0-2-6"},{"type":"extras","title":"v0.2.5 - Changelog","doc":"* Updates\n  * Verify firmware signatures in `firmware_update.livemd`","ref":"changelog.html#v0-2-5"},{"type":"extras","title":"v0.2.4 - Changelog","doc":"* Updates\n  * Start signing firmware updates and add info on how. This doesn't check\n    firmware signatures yet. That will be the next release.","ref":"changelog.html#v0-2-4"},{"type":"extras","title":"v0.2.3 - Changelog","doc":"* Updates\n  * Minor firmware update livebook improvements","ref":"changelog.html#v0-2-3"},{"type":"extras","title":"v0.2.2 - Changelog","doc":"* Updates\n  * Add welcome\n  * Update Livebook to latest","ref":"changelog.html#v0-2-2"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"* Bug fixes\n  * Clean up /data/livebooks. This may be worth a complete re-flash to clean up\n    the MicroSD card.\n\n* Updates\n  * Update Livebook to try import feature","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"This release no longer copies the built-in Livebooks to the data partition.\nThey're no symlinked so that they remain read-only and update on firmware\nupdates. You now have to fork them to run them.\n\n* New features\n  * A firmware update example","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.1 - Changelog","doc":"Initial CI-built release","ref":"changelog.html#v0-1-1"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}